/*=== Copyright (c) 2000 Sollae Systems Co.,Ltd. ===*/
/*=============== All rights reserved ==============*/

/*
modification history:
06.Jun.2000 yyc  initial touch
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

static unsigned char send_buf[1024];
static unsigned char recv_buf[1024];

void main(void)
{
	struct sockaddr_in sock_in;
	int sockfd, newfd, addr_len, len;

	/* formal listening sequence on UNIX: socket() -> bind() -> listen() */
	sockfd = socket(AF_INET, SOCK_STREAM, 0);
	if(sockfd < 0)
	{
		perror("socket:");
		return;
	}
	memset((void *)&sock_in, 0, sizeof(sock_in));
	sock_in.sin_family      = AF_INET;
	sock_in.sin_addr.s_addr = htonl(INADDR_ANY);
	sock_in.sin_port        = htons(1470);
	if(bind(sockfd, (struct sockaddr *)&sock_in, sizeof(sock_in)) < 0)
	{
		perror("bind:");
		close(sockfd);
		return;
	}
	if(listen(sockfd, 1) < 0)
	{
		perror("listen:");
		close(sockfd);
		return;
	}

__again:
	/* wait peer connect to me listening on 1470 TCP port */
	newfd = accept(sockfd, (struct sockaddr *)&sock_in, &addr_len);
	if(newfd < 0)
	{
		perror("accept:");
		close(sockfd);
		return;
	}

	len = recv(newfd, recv_buf, 1024, 0);
	if(len < 0)
	{
		perror("recv:");
		close(newfd);
		goto __again;
	}

	/* show notification message */
	printf("request from %s: ", inet_ntoa(sock_in.sin_addr));
	printf("%d", recv_buf[0]);
	if(recv_buf[0] >= 0x20)
		printf("(%c)\n", recv_buf[0]);
	else
		printf("\n");

	/* build response message string: decimal ASCII code */
	len = sprintf(send_buf, "%d", recv_buf[0]);

	/* send it */
	if(send(newfd, send_buf, len, 0) < 0)
	{
		perror("send:");
		close(newfd);
		goto __again;
	}

	/* close current connection */
	close(newfd);

	/* wait another request again */
	goto __again;
}
